PUBLIC setup_dirtyrects, process_dirtyrects, dirty_rects
EXTERN spritecolor

dirty_rects:    equ $e9fd

setup_dirtyrects:                       ; fill buffer with inc de
        ld hl,dirty_rects
        ld de,dirty_rects+1
        ld bc,767
        ld (hl),$13                     ; $13 = inc de
        ldir
                                        ; end buffer with jp dirtydone
        inc hl
        ld (hl),$c3                     ; jp
        inc hl
        ld (hl),dirtydone % 256
        inc hl
        ld (hl),dirtydone / 256

        ret

process_dirtyrects:

        ld de,0                 ; start at beginning of buffer
        ld hl,dirty_rects       ; load call address with start address
        ld (cdr+1),hl
        or h                     ; reset zero flag, h always != 0
processloop:
cdr:    call $0000               ; placeholder for entry to dirty_rects buffer, returns with de as index to dirty block
        ld hl,dirty_rects       ; restore base address
        add hl,de               ; add index, hl = address to block
        ld a,(hl)
        ld (hl),$13             ; off for testing. restore "inc de" to mark cell clean

        cp $c9                   ; is it $c9 = ret?
        jp z,inkit              ; yes, clear cell and ink it in
        ld b,$0f                 ; else $c0 = ret nz for "delete" cell
        jp plmoveon

inkit:
        ld a,d
        or $58                 ; add $58 to buffer high to point at attributes
        ld h,a
        ld l,e
        ld a,(spritecolor)      ; global variable for sprite color
        ld c,a
        ld a,(hl)               ; grab current attribute
        and %01111000           ; clear ink portion
        or c                    ; or in the spritecolor
        ld (hl),a               ; put it back on screen
        ld b,$00                ; pattern to use for cell fill stage

plmoveon:  

        ld l,e                  ; low byte always the same
        ld a,d                  ; rotate high bits into screen address
        rlca
        rlca
        rlca
        or $40                  ; add screen base address
        ld h,a

REPT 7                          ; fill block with b
        ld (hl),b
        inc h                   ; next pixel row
ENDR
        ld (hl),b

skipdraw:
        inc de                  ; next in buffer
        ld hl,dirty_rects       ; restore base address
        add hl,de               ; call dirty_rects on last ret + 1
        ld (cdr+1),hl           ; update call instruction
        jp processloop          ; loop until dirty_rects jumps to dirtydone below

dirtydone:
        pop hl                  ; pop off call to dirty_rects return address

        ret