PUBLIC rotate_byte, rotate_mirror, generate_lookups

rotate_byte:    equ $ed00       ; data in low byte, rotations + $ed in high
rotate_mirror:  equ $f500

generate_lookups:
        ld hl,rotate_byte
        ld de,rotate_mirror
lookup_loop:
        ld b,8      ; number tof rotations per byte
        ld iyl,e      ; value to be rotated
        ld a,e      ; same value to be flipped

        ; fast byte mirror
        ld c,a      ; a = 76543210
        rlca
        rlca        ; a = 54321076
        xor c
        and 0xAA
        xor c     ; a = 56341270
        ld c,a
        rlca
        rlca
        rlca        ; a = 41270563
        rrc c     ; c = 05634127
        xor c
        and 0x66
        xor c     ; a = 01234567

rotateloop:
        ld c,iyl
        ld (hl),c
        inc h
        rrc c
        ld iyl,c

        ld (de),a
        inc d        
        rrca

        djnz rotateloop

; debug break
;        di
;        halt
        ld h,rotate_byte/256        ; reset high bytes of buffers
        ld d,rotate_mirror/256
        inc l                       ; move to next low byte
        inc e
        jr nz,lookup_loop

        ret