EXTERN generate_lookups, setup_dirtyrects, process_dirtyrects, put_sprite, put_mirror, delete_sprite, mask_sprite, spritedata, spritecolor

;SECTION loram

MACRO dospriteroutines xy
        ld bc,xy
	call delete_sprite
        ld bc,xy
	call mask_sprite
ENDM

MACRO putit xy
        ld bc,xy
        ld hl,spritedata
        call put_sprite
ENDM

ORG $8000

	call setup_dirtyrects
        call init_interrupts
        ld sp,0     ; now safe to change sp
        call generate_lookups
	call setup_screen
forever:
	call sprite_test_routine
	jp forever

setup_screen:
	ld bc,6144-1
	ld hl,$4000
	ld de,$4001
	ld (hl),$0f
	ldir
	inc hl
	inc de
	ld (hl),$38
	ld bc,768-32-1
	ldir
	inc hl
	inc de
	ld (hl),$13
	ld bc,31
	ldir

	ld a,0
	ld (spritecolor),a
	ret

init_interrupts:
	di
	ld de,$fe00
	ld hl,$fdfd
	ld a,d
	ld i,a
	ld a,l
iil:	ld (de),a		; fill interrupt table (257 bytes)
	inc e
	jr nz,iil
	inc d
	ld (de),a
	ld (hl),$c3	; jp
	inc l
	ld (hl),isr % 256
	inc l
	ld (hl),isr / 256
	im 2
	ei
        ret
        
isr:
        ei
        reti

anim: db 0

sprite_test_routine:

        ld a,1
        out ($fe),a

	ld b,83
	ld a,(anim)
	ld c,a
	call delete_sprite
	ld b,83
	ld a,(anim)
	inc a
	ld c,a
	ld (anim),a
	call mask_sprite

	dospriteroutines $8121
	dospriteroutines $4181
	dospriteroutines $4389
	dospriteroutines $67e0

;        halt
        ld a,3
        out ($fe),a

; wait for $13 on the floating bus
        ld de,$1340
wfn:    dec hl
	ld a,e
        in a,($ff)
        cp d            ;is it D?
        jp nz,wfn        ;no? keep trying

        ld a,0
        out ($fe),a

	call process_dirtyrects

        ld a,5
        out ($fe),a

	ld b,83
	ld a,(anim)
	ld c,a
	ld hl,spritedata
	call put_sprite

	putit $8121
	putit $4389
	putit $4181
	putit $67e0

        ret
